import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import { Injectable } from '@angular/core';
import 'rxjs/add/operator/toPromise';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class EuPageService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class BaseAction {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.key = options.key;
        this.name = options.name;
        this.icon = options.icon;
        this.order = options.order === undefined ? 999 : options.order;
        this.style = options.style;
        this.modalConfig = options.modalConfig;
    }
}
/**
 * @record
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class CURDAction extends BaseAction {
    /**
     * @param {?} options
     */
    constructor(options) {
        super(options);
        this.curdType = options.curdType;
    }
}
CURDAction.TYPE_CREATE = '1';
CURDAction.TYPE_UPDATE = '2';
CURDAction.TYPE_READ = '3';
CURDAction.TYPE_DELETE = '4';
CURDAction.TYPE_QUERY = '5';
CURDAction.defaultAtcions = {
    TYPE_CREATE: {
        icon: 'add',
        style: "basic"
    },
    TYPE_UPDATE: {
        icon: 'mode_edit',
        style: "primary"
    },
    TYPE_QUERY: {
        icon: 'search',
        style: "accent"
    },
    TYPE_READ: {
        icon: 'sync',
        style: "accent"
    },
    TYPE_DELETE: {
        icon: 'delete_forever',
        style: "warn"
    },
};
CURDAction.CREATE = new CURDAction({
    key: "add", name: "新增", order: 1,
    curdType: CURDAction.TYPE_CREATE,
    icon: "add",
    // icon: CURDAction.defaultAtcions[CURDAction.TYPE_CREATE].icon
    style: "basic"
});
CURDAction.UPDATE = new CURDAction({
    key: "edit", name: "编辑", order: 2,
    curdType: CURDAction.TYPE_UPDATE,
    icon: "mode_edit",
    // icon: CURDAction.defaultAtcions[CURDAction.TYPE_UPDATE].icon
    style: "primary"
});
CURDAction.QUERY = new CURDAction({
    key: "refresh", name: "查询", order: 3,
    curdType: CURDAction.TYPE_QUERY,
    icon: "search",
    // icon: CURDAction.defaultAtcions[CURDAction.TYPE_QUERY].icon
    style: "accent"
});
CURDAction.READ = new CURDAction({
    key: "query", name: "刷新", order: 4,
    curdType: CURDAction.TYPE_READ,
    icon: "sync",
    // icon: CURDAction.defaultAtcions[CURDAction.TYPE_READ].icon
    style: "accent"
});
CURDAction.DELETE = new CURDAction({
    key: "delete", name: "删除", order: 5,
    curdType: CURDAction.TYPE_DELETE,
    icon: "delete_forever",
    // icon: CURDAction.defaultAtcions[CURDAction.TYPE_DELETE].icon
    style: "warn"
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class EuGridOptions {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.multiboxonly = true;
        this.sortable = false;
        this.scrollrows = true;
        this.pgbuttons = true;
        this.pginput = true;
        this.viewrecords = true;
        this.toppager = false;
        this.altRows = true;
        this.shrinkToFit = true;
        this.forceFit = false;
        this.hiddengrid = false;
        this.hidegrid = true;
        //				gridstate:"visible",//定义当前表格的状态：'visible' or 'hidden'
        //				multikey: "ctrlKey",
        //		        prmNames:{page:"page",rows:"rows", sort:"sidx", order:"sord", search:"_search", nd:"nd", id:"id", oper:"oper", editoper:"edit", addoper:"add", deloper:"del", subgridid:"id", npage:null, totalrows:"totalrows"},
        this.cellEdit = false;
        //				ajaxGridOptions:
        //				ajaxSelectOptions:
        this.autoencode = true;
        this.gridview = false;
        this.rowDragManaged = true;
        this.gridId = options.gridId;
        this.url = options.url;
        this.primaryKey = options.primaryKey;
        this.multiselect = options.multiselect == undefined ? true : options.multiselect;
        this.title = options.title;
        this.queryfields = options.queryfields || [];
        this.mtype = options.mtype == undefined ? "get" : options.mtype;
        this.defaultActionModalConfig = options.defaultActionModalConfig;
        this.actions = options.defaultaction == true ? [
            CURDAction.CREATE,
            CURDAction.UPDATE,
            CURDAction.QUERY,
            CURDAction.READ,
            CURDAction.DELETE,
        ] : options.actions;
        this.rowNum = options.rowNum == undefined ? 10 : options.rowNum;
        this.postData = options.postData == undefined ? {} : options.postData;
        this.rowDragManaged = options.rowDragManaged == undefined ? false : options.rowDragManaged;
        this.sortable = options.sortable || false;
        this.suppressRowDrag = options.suppressRowDrag == undefined ? false : options.suppressRowDrag;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class EuGridEvent {
    /**
     * @param {?} gridId
     * @param {?} action
     * @param {?=} rowId
     * @param {?=} rowIds
     * @param {?=} rowData
     * @param {?=} rowDatas
     * @param {?=} data
     */
    constructor(gridId, action, rowId, rowIds, rowData, rowDatas, data) {
        this.gridId = gridId;
        this.action = action;
        this.rowId = rowId;
        this.rowIds = rowIds;
        this.rowData = rowData;
        this.rowDatas = rowDatas;
        this.data = data;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class EuGridAction extends BaseAction {
    /**
     * @param {?} options
     */
    constructor(options) {
        super(options);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class EuColModel {
    /**
     * @param {?=} options
     */
    constructor(options = {}) {
        this.headerName = options.headerName;
        this.field = options.field;
        this.width = options.width;
        this.formatter = options.formatter;
        this.hidden = options.hidden;
        this.key = options.key;
        this.align = options.align;
        this.classes = options.classes;
        this.sortable = options.sortable;
        this.resizable = options.resizable;
        this.fixed = options.frozen;
        this.index = options.index;
        this.dragable = options.dragable;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class Conditions {
    /**
     * @param {?} groupOp
     * @param {?} rules
     * @param {?} groups
     */
    constructor(groupOp, rules, groups) {
        this.groupOp = groupOp;
        this.rules = rules;
        this.groups = groups;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class Rule {
    /**
     * @param {?} field
     * @param {?} op
     * @param {?} data
     */
    constructor(field, op, data) {
        this.field = field;
        this.op = op;
        this.data = data;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ModalConfig {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ModalAction extends BaseAction {
    /**
     * @param {?} options
     */
    constructor(options) {
        super(options);
        this.isCancel = options.isCancel;
        this.isClose = options.isClose;
        this.isReset = options.isReset;
    }
}
ModalAction.CANCEL = new ModalAction({ key: "cancel", name: "取消", order: 1, isCancel: true, style: "default" });
ModalAction.SAVE = new ModalAction({ key: "save", name: "保存", order: 2, isClose: true, style: "primary" });
ModalAction.CONFIRM = new ModalAction({ key: "confirm", name: "确定", order: 3, isClose: true, style: "primary" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class EuModalService {
    constructor() {
        this._smodalstack = [];
    }
}
EuModalService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
EuModalService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class EuBpmnService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
        this.CamundaArray = {
            activiti: ["activiti:collection", "activiti:candidateUsers", "activiti:elementVariable"],
            camunda: ["camunda:collection", "camunda:candidateUsers", "camunda:elementVariable"]
        };
    }
    /**
     * @param {?} activitiXml
     * @return {?}
     */
    activitiToCamundaAdapt(activitiXml) {
        this.CamundaArray.activiti.forEach((str, index) => {
            var /** @type {?} */ reg = "/" + str + "/ig";
            activitiXml = activitiXml.replace(eval(reg), this.CamundaArray.camunda[index]);
        });
        return activitiXml;
    }
    /**
     * @param {?} camundaXml
     * @return {?}
     */
    camundaToActivitiAdapt(camundaXml) {
        this.CamundaArray.camunda.forEach((str, index) => {
            var /** @type {?} */ reg = "/" + str + "/ig";
            camundaXml = camundaXml.replace(eval(reg), this.CamundaArray.activiti[index]);
        });
        return camundaXml;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class Model {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class EuDictService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class EuTree {
}
/**
 * @record
 */

/**
 * @abstract
 */
class EuTreeNode {
}
class TreeEvent {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.businessId = options.businessId;
        this.action = options.action;
        this.activeEuNodes = options.activeEuNodes;
        this.selectedEuNodes = options.selectedEuNodes;
        this.data = options.data;
    }
}
class TreeAction extends BaseAction {
    /**
     * @param {?} options
     */
    constructor(options) {
        super(options);
    }
}
class EuTreeOptions {
    /**
     * @param {?=} options
     */
    constructor(options = {
            treeId: "defaultZtreeId",
            dataUrl: "dataUrl"
        }) {
        this.actions = [];
        //otherParam
        this.params = {};
        //自动提交参数
        this.autoParam = ["id", "pid"];
        //初始展开所有
        this.expendAll = false;
        //初始展开层级
        this.expendLevel = 1;
        //多选 按住ctrl键可多选
        this.selectedMulti = false;
        //勾选
        this.checkEnable = false;
        //checkbox 或 radio
        this.checkStyle = "checkbox";
        // Y 属性定义 checkbox 被勾选后的情况；
        // N 属性定义 checkbox 取消勾选后的情况；
        // "p" 表示操作会影响父级节点；
        // "s" 表示操作会影响子级节点。
        this.chkboxType = { "Y": "p", "N": "s" };
        // 设置自动关联勾选时是否触发 beforeCheck / onCheck 事件回调函数。
        this.autoCheckTrigger = false;
        this.treeId = options.treeId;
        this.dataUrl = options.dataUrl;
        this.actions = options.actions == undefined ? [] : options.actions;
        this.nameIsHTML = options.nameIsHTML == undefined ? false : options.nameIsHTML;
        this.params = options.params;
        this.autoParam = options.autoParam == undefined ? ["id", "pid"] : options.autoParam;
        this.expendAll = options.expendAll == undefined ? false : options.expendAll;
        this.expendLevel = options.expendLevel == undefined ? 1 : options.expendLevel;
        this.selectedMulti = options.selectedMulti == undefined ? false : options.selectedMulti;
        this.checkEnable = options.checkEnable == undefined ? false : options.checkEnable;
        this.checkStyle = options.checkStyle == undefined ? "checkbox" : options.checkStyle;
        this.chkboxType = options.chkboxType == undefined ? { "Y": "p", "N": "s" } : options.chkboxType;
        this.autoCheckTrigger = options.autoCheckTrigger == undefined ? false : options.autoCheckTrigger;
        this.nodeCheck = options.nodeCheck;
        this.nodeClick = options.nodeClick;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class EuTreeService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class Menu {
    /**
     * @param {?} options
     */
    constructor(options) {
        this.id = options.id;
        this.i = options.i;
        this.t = options.t;
        this.l = options.l;
        this.isSelected = options.isSelected;
        this.c = options.c;
        this.active = options.active;
        this.parent = options.parent;
        this.o = options.o;
        this.e = options.e;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { EuPageService, EuGridOptions, EuGridEvent, EuGridAction, EuColModel, Conditions, Rule, BaseAction, CURDAction, ModalConfig, ModalAction, EuModalService, EuBpmnService, Model, EuDictService, EuTreeNode, EuTreeOptions, TreeAction, TreeEvent, EuTree, EuTreeService, Menu };
//# sourceMappingURL=core.js.map
