import { EventEmitter, OnInit } from "@angular/core";
import { PageEvent, MatPaginator, MatDialog, MatSnackBar } from '@angular/material';
import { GridOptions, IDatasource, ColDef, ColGroupDef, RowNode, DraggingEvent } from "ag-grid/main";
import 'rxjs/add/observable/interval';
import { EuGridOptions, EuColModel, GridApi, EuGridAction, EuGridEvent, ModalConfig } from 'ng2-easyui.core';
import { EuModalService } from "ng2-easyui.core";
import { EuPageService } from "ng2-easyui.core";
import { FieldBase, MdFormComponent } from 'ng2-easyform';
export declare class AggridComponent implements GridApi, OnInit {
    private euModalService;
    private pageService;
    dialog: MatDialog;
    snackBar: MatSnackBar;
    euColModels: EuColModel[];
    euGridOptions: EuGridOptions;
    agGridColDefs: (ColDef | ColGroupDef)[];
    rowModelType: string;
    inputPageService: EuPageService;
    aggridOptions: GridOptions;
    myDataSource: IDatasource;
    url: string;
    rowData: any[];
    length: number;
    pageSize: number;
    pageSizeOptions: number[];
    pageIndex: number;
    sidx: string;
    sord: string;
    queryExpanded: boolean;
    tableWidth: string;
    queryfields: FieldBase<any>[];
    originParams: any;
    originQueryParams: any;
    private _queryParams;
    lastRow: number;
    cacheBlockSize: number;
    paginator: MatPaginator;
    queryForm: MdFormComponent;
    pageEvent: PageEvent;
    euGridEvent: EventEmitter<EuGridEvent>;
    dragEvent: EventEmitter<DraggingEvent>;
    rowDragEnter: EventEmitter<DraggingEvent>;
    rowDragEnd: EventEmitter<DraggingEvent>;
    rowDragMove: EventEmitter<DraggingEvent>;
    rowDragLeave: EventEmitter<DraggingEvent>;
    defaultAtcions: {
        [x: string]: {
            icon: string;
            "style": string;
        };
    };
    constructor(euModalService: EuModalService, pageService: EuPageService, dialog: MatDialog, snackBar: MatSnackBar);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private readonly cond;
    query($event?: any): void;
    reset($event?: any): void;
    private doQueryParams(queryParams, fields);
    refreshData(url: string, pageSize: number, pageIndex: number, cond: any, sidx: string, sord: string): Promise<void>;
    gridReady($event: any): void;
    reComputeSize(): void;
    onSortChanged($event: any): void;
    private createColumnDefs();
    attachComparatorToColDefs(defs: any[]): void;
    openDialog(modalConfig: ModalConfig, data: any): void;
    onAction(action: EuGridAction): void;
    refresh(params?: any): void;
    toggleSuppressRowDrag(suppress?: boolean): void;
    addParams: (params, fresh?: boolean) => void;
    removeParam: (paramName, fresh?) => void;
    setParams(params: any, fresh?: any): void;
    private actionParams;
    /**
     * 设置action的外部参数（非rowId这些）
     * @param actionKey
     * @param param
     * @param all 是否所有action生效
     */
    setActionParams(actionKey: string, param: any, all?: boolean): void;
    getActionParams(key: string): any;
    getRowDataIds: () => any[];
    getRowData: (rowId: any) => RowNode;
    getRowDatas: () => RowNode[];
    getSingleSelectedRowId: () => any;
    getSelectedRowIds: () => any[];
    getSingleSelectedData: () => any;
    getSelectedDatas: () => any[];
    private convertMap;
    private enColModelToAgColDef(col);
    private getPageService();
}
