import { Component, EventEmitter, Input, NgModule, Optional, Output, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { MatButtonModule, MatDialog, MatExpansionModule, MatIconModule, MatInputModule, MatPaginator, MatPaginatorModule, MatSnackBar, MatSnackBarModule, MatTooltipModule } from '@angular/material';
import { AgGridModule } from 'ag-grid-angular/main';
import { debounce } from 'rxjs/operators';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/interval';
import { CURDAction, Conditions, EuGridEvent, EuModalService, EuPageService, Rule } from 'ng2-easyui.core';
import { EasyFormMdModule, MdFormComponent } from 'ng2-easyform';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var localeText = {
    // for filter panel
    page: 'Page',
    more: 'More',
    to: 'To',
    of: 'Of',
    next: 'Next',
    last: 'Last',
    first: 'First',
    previous: 'Previous',
    loadingOoo: 'Loading...',
    // for set filter
    selectAll: 'Select All',
    searchOoo: 'Search...',
    blanks: 'Blanc',
    // for number filter and text filter
    filterOoo: 'Filter...',
    applyFilter: 'ApplyFilter...',
    // for number filter
    equals: 'Equals',
    lessThan: 'LessThan',
    greaterThan: 'GreaterThan',
    // for text filter
    contains: 'Contains',
    startsWith: 'Starts with',
    endsWith: 'Ends with',
    // the header of the default group column
    group: 'Group',
    // tool panel
    columns: 'Columns',
    rowGroupColumns: 'Pivot Cols',
    rowGroupColumnsEmptyMessage: ' drag cols to group',
    valueColumns: 'Value Cols',
    pivotMode: 'Pivot-Mode',
    groups: 'Groups',
    values: 'Values',
    pivots: 'Pivots',
    valueColumnsEmptyMessage: ' drag cols to aggregate',
    pivotColumnsEmptyMessage: ' drag here to pivot',
    // other
    noRowsToShow: ' no rows',
    // enterprise menu
    // pinColumn: 'Pin Column',
    // valueAggregation: 'Value Agg',
    // autosizeThiscolumn: 'Autosize Diz',
    // autosizeAllColumns: 'Autsoie em All',
    // groupBy: 'Group by',
    // ungroupBy: 'UnGroup by',
    // resetColumns: 'Reset Those Cols',
    // expandAll: 'Open-em-up',
    // collapseAll: ',Close-em-up',
    // toolPanel: ',Tool Panelo',
    // export: ',Exporto',
    // csvExport: ', CSV Exportp',
    // excelExport: ', Excel Exporto',
    // enterprise menu pinning
    // pinLeft: ',Pin <<',
    // pinRight: ',Pin >>',
    // noPin: ',DontPin <>',
    // enterprise menu aggregation and status panel
    // sum: ',Sum',
    // min: ',Min',
    // max: ',Max',
    // first: ',First',
    // last: ',,st',
    // none: ',None',
    // count: ',Count',
    // average: ',Average',
    // standard menu
    copy: 'Copy',
    copyWithHeaders: 'Copy Wit Headers',
    ctrlC: 'ctrl C',
    paste: 'Paste',
    ctrlV: 'ctrl C'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var AggridComponent = (function () {
    // MdPaginator Output
    // pageEvent: PageEvent;
    function AggridComponent(euModalService, pageService, dialog, snackBar) {
        var _this = this;
        this.euModalService = euModalService;
        this.pageService = pageService;
        this.dialog = dialog;
        this.snackBar = snackBar;
        this.rowModelType = 'inMemory';
        this.url = 'ls/list/form/webdiscategorymanage';
        this.rowData = [];
        this.length = 100;
        this.pageSize = 10;
        this.pageSizeOptions = [5, 10, 25, 100];
        this.pageIndex = 1;
        this.queryExpanded = false;
        this.tableWidth = "100%";
        //表格的初始化参数
        this.originParams = {};
        //初始化的查询参数
        this.originQueryParams = {};
        this._queryParams = {};
        this.lastRow = 0;
        this.cacheBlockSize = 10;
        this.euGridEvent = new EventEmitter();
        this.dragEvent = new EventEmitter();
        this.rowDragEnter = new EventEmitter();
        this.rowDragEnd = new EventEmitter();
        this.rowDragMove = new EventEmitter();
        this.rowDragLeave = new EventEmitter();
        this.defaultAtcions = (_a = {},
            _a[CURDAction.TYPE_CREATE] = {
                icon: 'add',
                "style": "basic"
            },
            _a[CURDAction.TYPE_UPDATE] = {
                icon: 'mode_edit',
                "style": "primary"
            },
            _a[CURDAction.TYPE_QUERY] = {
                icon: 'search',
                "style": "accent"
            },
            _a[CURDAction.TYPE_READ] = {
                icon: 'sync',
                "style": "accent"
            },
            _a[CURDAction.TYPE_DELETE] = {
                icon: 'delete_forever',
                "style": "warn"
            },
            _a);
        this.actionParams = {};
        this.getRowDataIds = function () {
            return _this.getRowDatas().map(function (node) {
                return node.data[_this.euGridOptions.primaryKey];
            });
        };
        //获取指定列的数据 rowId:主列的值;如果rowId为空，则返回表格全部数据。
        this.getRowData = function (rowId) {
            return _this.aggridOptions.api.getRowNode(rowId);
        };
        //获取所有数据 in memory
        this.getRowDatas = function () {
            return _this.aggridOptions.api.getRenderedNodes();
        };
        //获取表格信息。param:"rowNum"-每页记录条数 "page"-当前第几页 “records”-总共有多少条
        // getGridParam = function (param) {
        //     return this.jqgridObject.jqGrid("getGridParam", param);
        // }
        //获取单个选中的行的主列值，如果选中多个这返回最后选中的值
        this.getSingleSelectedRowId = function () {
            return _this.getSingleSelectedData()[_this.euGridOptions.primaryKey];
        };
        //获取所有选中的行的主列值，返回数组
        this.getSelectedRowIds = function () {
            var /** @type {?} */ ids = [];
            var /** @type {?} */ datas = _this.aggridOptions.api.getSelectedRows();
            datas.forEach(function (v) {
                ids.push(v[_this.euGridOptions.primaryKey]);
            });
            return ids;
        };
        //返回单个选中的行数据
        this.getSingleSelectedData = function () {
            var /** @type {?} */ datas = _this.aggridOptions.api.getSelectedRows();
            return datas[0];
        };
        //返回所有选中行数据的数组
        this.getSelectedDatas = function () {
            return _this.aggridOptions.api.getSelectedRows();
        };
        this.convertMap = {
            headerName: "headerName",
            field: "field",
        };
        var /** @type {?} */ cacheBlockSize = this.cacheBlockSize;
        //infinite 模式使用
        this.myDataSource = {
            // Callback the grid calls that you implement to fetch rows from the server. See below for params.
            getRows: /**
             * @param {?} params
             * @return {?}
             */
            function (params) {
                console.log('asking for ' + params.startRow + ' to ' + params.endRow);
                // At this point in your code, you would call the server, using $http if in AngularJS 1.x.
                // To make the demo look real, wait for 500ms before returning
                // pageService.getPageObol("/ls/list/form/webdiscategorymanage", params.startRow, cacheBlockSize).toPromise().then(data => {
                this.getPageService().getPageObByOffsetLimit("list/e/webdisplaycategory", params.startRow, cacheBlockSize).toPromise().then(function (data) {
                    var /** @type {?} */ lastRow = -1;
                    if (data.total <= params.endRow) {
                        lastRow = data.total;
                    }
                    params.successCallback(data.contents, lastRow);
                });
            }
        };
        var _a;
    }
    /**
     * @return {?}
     */
    AggridComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.queryfields = this.euGridOptions.queryfields;
        this.aggridOptions = /** @type {?} */ ({
            columnDefs: this.createColumnDefs(),
            rowModelType: this.rowModelType,
            datasource: this.myDataSource,
            rowData: this.rowData,
            domLayout: 'autoHeight',
            //不出现上下滚动条
            cacheBlockSize: this.cacheBlockSize,
            enableServerSideFilter: true,
            enableColResize: true,
            // pagination: true,
            localeText: localeText,
            enableSorting: this.euGridOptions.suppressRowDrag,
            suppressRowDrag: true,
            enableFilter: false,
            suppressRowClickSelection: false,
            suppressCellSelection: true,
            groupSelectsChildren: true,
            // debug: true,
            rowSelection: 'multiple',
            rowDragManaged: this.euGridOptions.rowDragManaged,
            getRowNodeId: function (data) {
                return data[_this.euGridOptions.primaryKey];
            },
            onRowDragEnter: function (event) {
                _this.dragEvent.emit(event);
                _this.rowDragEnter.emit(event);
            },
            onRowDragEnd: function (event) {
                _this.dragEvent.emit(event);
                _this.rowDragEnd.emit(event);
            },
            onRowDragMove: function (event) {
                _this.dragEvent.emit(event);
                _this.rowDragMove.emit(event);
            },
            onRowDragLeave: function (event) {
                _this.dragEvent.emit(event);
                _this.rowDragLeave.emit(event);
            },
        });
        this.url = this.euGridOptions.url;
        if (this.euGridOptions.width) {
            this.tableWidth = this.euGridOptions.width + 'px';
        }
    };
    /**
     * @return {?}
     */
    AggridComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.paginator.page.subscribe(function (data) {
            _this.pageSize = _this.paginator.pageSize;
            _this.pageIndex = _this.paginator.pageIndex + 1;
            _this.refreshData(_this.url, _this.pageSize, _this.pageIndex, _this.cond, _this.sidx, _this.sord);
        });
        // this.queryForm.form.valueChanges.debounce(() => Observable.interval(400)).subscribe(value => {
        //     this.query()
        // })
        this.queryForm.form.valueChanges.pipe(debounce(function () { return Observable.interval(400); })).subscribe(function (value) {
            _this.query();
        });
        //初始化的查询参数
        this.queryForm.form.patchValue(this.originQueryParams);
    };
    Object.defineProperty(AggridComponent.prototype, "cond", {
        get: /**
         * @return {?}
         */
        function () {
            return Object.assign({}, this.originParams, this.originQueryParams, this._queryParams);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?=} $event
     * @return {?}
     */
    AggridComponent.prototype.query = /**
     * @param {?=} $event
     * @return {?}
     */
    function ($event) {
        // debugger
        this._queryParams = this.queryForm.form.value;
        for (var /** @type {?} */ key in this._queryParams) {
            if (this._queryParams[key] == undefined || this._queryParams[key] == "") {
                delete this._queryParams[key];
            }
        }
        var /** @type {?} */ queryParams = {};
        Object.assign(queryParams, this.originParams, this._queryParams, this.originQueryParams);
        this.doQueryParams(queryParams, this.queryfields);
        this.refresh(queryParams);
    };
    /**
     * @param {?=} $event
     * @return {?}
     */
    AggridComponent.prototype.reset = /**
     * @param {?=} $event
     * @return {?}
     */
    function ($event) {
        this.queryForm.form.reset();
        this.queryForm.form.patchValue(this.originQueryParams);
        this._queryParams = this.queryForm.form.value;
        this.refresh(this.cond);
    };
    /**
     * @param {?} queryParams
     * @param {?} fields
     * @return {?}
     */
    AggridComponent.prototype.doQueryParams = /**
     * @param {?} queryParams
     * @param {?} fields
     * @return {?}
     */
    function (queryParams, fields) {
        var /** @type {?} */ rules = [];
        var _loop_1 = function (p) {
            fields.forEach(function (v) {
                if (v.key == p && queryParams[p] && v.op) {
                    if (v.op.advanced) {
                        var /** @type {?} */ filtersbefore = queryParams.filters;
                        var /** @type {?} */ rule = new Rule(v.key, v.op.name, queryParams[p]);
                        rules.push(rule);
                        delete queryParams[p];
                    }
                    // queryParams.
                }
            });
        };
        for (var /** @type {?} */ p in queryParams) {
            _loop_1(p);
        }
        if (rules.length > 0) {
            var /** @type {?} */ con = new Conditions("AND", rules, []);
            queryParams.filters = con;
        }
    };
    /**
     * @param {?} url
     * @param {?} pageSize
     * @param {?} pageIndex
     * @param {?} cond
     * @param {?} sidx
     * @param {?} sord
     * @return {?}
     */
    AggridComponent.prototype.refreshData = /**
     * @param {?} url
     * @param {?} pageSize
     * @param {?} pageIndex
     * @param {?} cond
     * @param {?} sidx
     * @param {?} sord
     * @return {?}
     */
    function (url, pageSize, pageIndex, cond, sidx, sord) {
        var _this = this;
        return this.getPageService().getPage(url, pageSize, pageIndex, cond, sidx, sord).then(function (data) {
            _this.length = data.total;
            _this.rowData = data.contents;
            _this.aggridOptions.api.setRowData(_this.rowData);
            // this.rowData = data
        });
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    AggridComponent.prototype.gridReady = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        var _this = this;
        this.reComputeSize();
        if (this.rowModelType == 'inMemory') {
            this.getPageService().getPage(this.url, this.pageSize, this.pageIndex, this.cond).then(function (data) {
                _this.length = data.total;
                _this.rowData = data.contents;
                _this.aggridOptions.api.setRowData(_this.rowData);
                // this.rowData = data
            });
        }
    };
    /**
     * @return {?}
     */
    AggridComponent.prototype.reComputeSize = /**
     * @return {?}
     */
    function () {
        this.aggridOptions.api.sizeColumnsToFit();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    AggridComponent.prototype.onSortChanged = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        var _this = this;
        var /** @type {?} */ sortModel = this.aggridOptions.api.getSortModel();
        var /** @type {?} */ sortCol = sortModel[0];
        if (sortCol) {
            this.sidx = sortCol.colId;
            this.sord = sortCol.sort;
            setTimeout(function () {
                _this.refresh();
            });
        }
    };
    /**
     * @return {?}
     */
    AggridComponent.prototype.createColumnDefs = /**
     * @return {?}
     */
    function () {
        if (this.euColModels) {
            var /** @type {?} */ colDefs = void 0;
            this.euColModels.forEach(function (value) {
                // colDefs
            });
            return colDefs;
        }
        else {
            this.attachComparatorToColDefs(this.agGridColDefs);
            return this.agGridColDefs;
        }
    };
    /**
     * @param {?} defs
     * @return {?}
     */
    AggridComponent.prototype.attachComparatorToColDefs = /**
     * @param {?} defs
     * @return {?}
     */
    function (defs) {
        var _this = this;
        defs.forEach(function (v) {
            if (v.children) {
                _this.attachComparatorToColDefs(v.children);
            }
            else {
                v.comparator = function (valueA, valueB, nodeA, nodeB, isInverted) {
                    return 0;
                };
            }
        });
    };
    /**
     * @param {?} modalConfig
     * @param {?} data
     * @return {?}
     */
    AggridComponent.prototype.openDialog = /**
     * @param {?} modalConfig
     * @param {?} data
     * @return {?}
     */
    function (modalConfig, data) {
        var _this = this;
        if (!modalConfig.data) {
            modalConfig.data = {};
        }
        Object.assign(modalConfig.data, data);
        this.euModalService.open(modalConfig, function (result) {
            _this.refresh();
        }, function (result) {
            _this.refresh();
        });
    };
    /**
     * @param {?} action
     * @return {?}
     */
    AggridComponent.prototype.onAction = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        var /** @type {?} */ ids = this.getSelectedRowIds();
        var /** @type {?} */ datas = this.getSelectedDatas();
        var /** @type {?} */ ege = new EuGridEvent(this.euGridOptions.gridId, action, ids.length > 0 ? ids[0] : undefined, ids, datas.length > 0 ? datas[0] : undefined, datas, this.getActionParams(action.key));
        if (action instanceof CURDAction) {
            switch (action.curdType) {
                case CURDAction.TYPE_CREATE:
                    var /** @type {?} */ modalConfig = action.modalConfig || this.euGridOptions.defaultActionModalConfig;
                    this.openDialog(modalConfig, {
                        euGridEvent: ege
                    });
                    break;
                case CURDAction.TYPE_UPDATE:
                    if (ids.length == 1) {
                        var /** @type {?} */ modalConfig1 = action.modalConfig || this.euGridOptions.defaultActionModalConfig;
                        this.openDialog(modalConfig1, { euGridEvent: ege });
                    }
                    else {
                        this.snackBar.open('请选择一条记录！', '关闭', {
                            duration: 800
                        });
                    }
                    break;
                case CURDAction.TYPE_QUERY:
                    this.queryExpanded = !this.queryExpanded;
                    break;
                case CURDAction.TYPE_READ:
                    this.refresh();
                    break;
                case CURDAction.TYPE_DELETE:
                    break;
                default:
            }
        }
        else {
            //有modal配置就是要打开modal咯
            if (action && action.modalConfig) {
                this.openDialog(action.modalConfig, { euGridEvent: ege });
            }
        }
        this.euGridEvent.emit(ege);
    };
    /**
     * @param {?=} params
     * @return {?}
     */
    AggridComponent.prototype.refresh = /**
     * @param {?=} params
     * @return {?}
     */
    function (params) {
        this.refreshData(this.url, this.pageSize, this.pageIndex, params || this.cond, this.sidx, this.sord);
    };
    /**
     * @param {?=} suppress
     * @return {?}
     */
    AggridComponent.prototype.toggleSuppressRowDrag = /**
     * @param {?=} suppress
     * @return {?}
     */
    function (suppress) {
        if (suppress == undefined) {
            this.aggridOptions.api.setSuppressRowDrag(!this.aggridOptions.suppressRowDrag);
        }
        else {
            this.aggridOptions.api.setSuppressRowDrag(suppress);
        }
    };
    /**
     * @param {?} params
     * @param {?=} fresh
     * @return {?}
     */
    AggridComponent.prototype.setParams = /**
     * @param {?} params
     * @param {?=} fresh
     * @return {?}
     */
    function (params, fresh) {
        this.originParams = params;
        if (fresh) {
            this.refresh();
        }
    };
    /**
     * 设置action的外部参数（非rowId这些）
     * @param actionKey
     * @param param
     * @param all 是否所有action生效
     */
    /**
     * 设置action的外部参数（非rowId这些）
     * @param {?} actionKey
     * @param {?} param
     * @param {?=} all 是否所有action生效
     * @return {?}
     */
    AggridComponent.prototype.setActionParams = /**
     * 设置action的外部参数（非rowId这些）
     * @param {?} actionKey
     * @param {?} param
     * @param {?=} all 是否所有action生效
     * @return {?}
     */
    function (actionKey, param, all) {
        if (all) {
            this.actionParams.all = param;
        }
        else {
            this.actionParams[actionKey] = param;
        }
    };
    /**
     * @param {?} key
     * @return {?}
     */
    AggridComponent.prototype.getActionParams = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return Object.assign({}, this.actionParams[key], this.actionParams.all);
    };
    /**
     * @param {?} col
     * @return {?}
     */
    AggridComponent.prototype.enColModelToAgColDef = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        var /** @type {?} */ colDef = {
            headerName: "编号",
            field: "categoryNo",
            checkboxSelection: function (params) {
                // we put checkbox on the name if we are not doing grouping
                return params.columnApi.getRowGroupColumns().length === 0;
            },
            headerCheckboxSelection: function (params) {
                // we put checkbox on the name if we are not doing grouping
                return params.columnApi.getRowGroupColumns().length === 0;
            },
        };
        return colDef;
    };
    /**
     * @return {?}
     */
    AggridComponent.prototype.getPageService = /**
     * @return {?}
     */
    function () {
        return this.inputPageService || this.pageService;
    };
    AggridComponent.decorators = [
        { type: Component, args: [{
                    selector: 'eu-aggrid',
                    template: "<div [style.width]=\"tableWidth\"> <h1>{{euGridOptions.title}}</h1> <div style=\"display: flex;\"> <span style=\"flex: 1 1 auto;\"></span> <button mat-icon-button [color]=\"action.style\" (click)=\"onAction(action)\" *ngFor=\"let action of euGridOptions.actions\"> <mat-icon class=\"mat-24\"  [matTooltip]=\"action.name\"  matTooltipPosition=\"above\" [attr.aria-label]=\"action.name\" [attr.title]=\"action.name\"> {{action.icon}} </mat-icon> </button> </div> <mat-expansion-panel [expanded]=\"queryExpanded\"> <ef-md-form [fields]=\"queryfields\"></ef-md-form> <mat-action-row> <button mat-button (click)=\"query($event)\">查询</button> <button mat-button (click)=\"reset($event)\">重置</button> </mat-action-row> </mat-expansion-panel> <!-- class=\"ag-blue\"  --> <div class=\"eu-md-table-container\"> <ag-grid-angular style=\"width: 100%;\" class=\"ag-theme-material\" [gridOptions]=\"aggridOptions\" (gridReady)=\"gridReady($event)\" (sortChanged)=\"onSortChanged($event)\"> </ag-grid-angular> </div> <mat-paginator #paginator [length]=\"length\" [pageSize]=\"pageSize\" [pageSizeOptions]=\"pageSizeOptions\" (page)=\"pageEvent = $event\"> </mat-paginator> </div>",
                    //     styles: [
                    //         `
                    // .eu-md-table-container {
                    //     transition: box-shadow 280ms cubic-bezier(.4,0,.2,1);
                    //     display: block;
                    //     position: relative;
                    //     /* padding: 24px; */
                    //     border-radius: 2px;
                    //     background: #fff;
                    //     color: rgba(0,0,0,.87);
                    //     box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);
                    // }
                    // `,
                    //     ],
                    styles: ["/* @import \"~ag-grid/dist/styles/ag-grid.css\"; */ /* @import \"../node_modules/ag-grid/dist/styles/theme-blue.css\"; */ /* @import \"~ag-grid/dist/styles/ag-theme-material.css\"; */ .eu-md-table-container { transition: box-shadow 280ms cubic-bezier(.4,0,.2,1); display: block; position: relative; /* padding: 24px; */ border-radius: 2px; background: #fff; color: rgba(0,0,0,.87); box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);     }"],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    AggridComponent.ctorParameters = function () { return [
        { type: EuModalService, },
        { type: EuPageService, decorators: [{ type: Optional },] },
        { type: MatDialog, },
        { type: MatSnackBar, },
    ]; };
    AggridComponent.propDecorators = {
        "euColModels": [{ type: Input },],
        "euGridOptions": [{ type: Input },],
        "agGridColDefs": [{ type: Input },],
        "rowModelType": [{ type: Input },],
        "inputPageService": [{ type: Input },],
        "url": [{ type: Input },],
        "tableWidth": [{ type: Input },],
        "originParams": [{ type: Input },],
        "originQueryParams": [{ type: Input },],
        "paginator": [{ type: ViewChild, args: [MatPaginator,] },],
        "queryForm": [{ type: ViewChild, args: [MdFormComponent,] },],
        "euGridEvent": [{ type: Output },],
        "dragEvent": [{ type: Output },],
        "rowDragEnter": [{ type: Output },],
        "rowDragEnd": [{ type: Output },],
        "rowDragMove": [{ type: Output },],
        "rowDragLeave": [{ type: Output },],
    };
    return AggridComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EasyUIagGridModule = (function () {
    function EasyUIagGridModule() {
    }
    EasyUIagGridModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        MatButtonModule,
                        MatIconModule,
                        MatPaginatorModule,
                        MatTooltipModule,
                        MatSnackBarModule,
                        MatInputModule,
                        MatExpansionModule,
                        EasyFormMdModule,
                        AgGridModule.withComponents([]),
                    ],
                    exports: [
                        AggridComponent,
                    ],
                    declarations: [
                        AggridComponent
                    ],
                    providers: [],
                    entryComponents: []
                },] },
    ];
    return EasyUIagGridModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { EasyUIagGridModule, AggridComponent };
//# sourceMappingURL=eu-ag-grid.es5.js.map
