import { Component, EventEmitter, Input, NgModule, Optional, Output, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { MatButtonModule, MatDialog, MatExpansionModule, MatIconModule, MatInputModule, MatPaginator, MatPaginatorModule, MatSnackBar, MatSnackBarModule, MatTooltipModule } from '@angular/material';
import { AgGridModule } from 'ag-grid-angular/main';
import { debounce } from 'rxjs/operators';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/interval';
import { CURDAction, Conditions, EuGridEvent, EuModalService, EuPageService, Rule } from 'ng2-easyui.core';
import { EasyFormMdModule, MdFormComponent } from 'ng2-easyform';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
let localeText = {
    // for filter panel
    page: 'Page',
    more: 'More',
    to: 'To',
    of: 'Of',
    next: 'Next',
    last: 'Last',
    first: 'First',
    previous: 'Previous',
    loadingOoo: 'Loading...',
    // for set filter
    selectAll: 'Select All',
    searchOoo: 'Search...',
    blanks: 'Blanc',
    // for number filter and text filter
    filterOoo: 'Filter...',
    applyFilter: 'ApplyFilter...',
    // for number filter
    equals: 'Equals',
    lessThan: 'LessThan',
    greaterThan: 'GreaterThan',
    // for text filter
    contains: 'Contains',
    startsWith: 'Starts with',
    endsWith: 'Ends with',
    // the header of the default group column
    group: 'Group',
    // tool panel
    columns: 'Columns',
    rowGroupColumns: 'Pivot Cols',
    rowGroupColumnsEmptyMessage: ' drag cols to group',
    valueColumns: 'Value Cols',
    pivotMode: 'Pivot-Mode',
    groups: 'Groups',
    values: 'Values',
    pivots: 'Pivots',
    valueColumnsEmptyMessage: ' drag cols to aggregate',
    pivotColumnsEmptyMessage: ' drag here to pivot',
    // other
    noRowsToShow: ' no rows',
    // enterprise menu
    // pinColumn: 'Pin Column',
    // valueAggregation: 'Value Agg',
    // autosizeThiscolumn: 'Autosize Diz',
    // autosizeAllColumns: 'Autsoie em All',
    // groupBy: 'Group by',
    // ungroupBy: 'UnGroup by',
    // resetColumns: 'Reset Those Cols',
    // expandAll: 'Open-em-up',
    // collapseAll: ',Close-em-up',
    // toolPanel: ',Tool Panelo',
    // export: ',Exporto',
    // csvExport: ', CSV Exportp',
    // excelExport: ', Excel Exporto',
    // enterprise menu pinning
    // pinLeft: ',Pin <<',
    // pinRight: ',Pin >>',
    // noPin: ',DontPin <>',
    // enterprise menu aggregation and status panel
    // sum: ',Sum',
    // min: ',Min',
    // max: ',Max',
    // first: ',First',
    // last: ',,st',
    // none: ',None',
    // count: ',Count',
    // average: ',Average',
    // standard menu
    copy: 'Copy',
    copyWithHeaders: 'Copy Wit Headers',
    ctrlC: 'ctrl C',
    paste: 'Paste',
    ctrlV: 'ctrl C'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class AggridComponent {
    /**
     * @param {?} euModalService
     * @param {?} pageService
     * @param {?} dialog
     * @param {?} snackBar
     */
    constructor(euModalService, pageService, dialog, snackBar) {
        this.euModalService = euModalService;
        this.pageService = pageService;
        this.dialog = dialog;
        this.snackBar = snackBar;
        this.rowModelType = 'inMemory';
        this.url = 'ls/list/form/webdiscategorymanage';
        this.rowData = [];
        this.length = 100;
        this.pageSize = 10;
        this.pageSizeOptions = [5, 10, 25, 100];
        this.pageIndex = 1;
        this.queryExpanded = false;
        this.tableWidth = "100%";
        //表格的初始化参数
        this.originParams = {};
        //初始化的查询参数
        this.originQueryParams = {};
        this._queryParams = {};
        this.lastRow = 0;
        this.cacheBlockSize = 10;
        this.euGridEvent = new EventEmitter();
        this.dragEvent = new EventEmitter();
        this.rowDragEnter = new EventEmitter();
        this.rowDragEnd = new EventEmitter();
        this.rowDragMove = new EventEmitter();
        this.rowDragLeave = new EventEmitter();
        this.defaultAtcions = {
            [CURDAction.TYPE_CREATE]: {
                icon: 'add',
                "style": "basic"
            },
            [CURDAction.TYPE_UPDATE]: {
                icon: 'mode_edit',
                "style": "primary"
            },
            [CURDAction.TYPE_QUERY]: {
                icon: 'search',
                "style": "accent"
            },
            [CURDAction.TYPE_READ]: {
                icon: 'sync',
                "style": "accent"
            },
            [CURDAction.TYPE_DELETE]: {
                icon: 'delete_forever',
                "style": "warn"
            },
        };
        this.actionParams = {};
        this.getRowDataIds = () => {
            return this.getRowDatas().map(node => {
                return node.data[this.euGridOptions.primaryKey];
            });
        };
        //获取指定列的数据 rowId:主列的值;如果rowId为空，则返回表格全部数据。
        this.getRowData = (rowId) => {
            return this.aggridOptions.api.getRowNode(rowId);
        };
        //获取所有数据 in memory
        this.getRowDatas = () => {
            return this.aggridOptions.api.getRenderedNodes();
        };
        //获取表格信息。param:"rowNum"-每页记录条数 "page"-当前第几页 “records”-总共有多少条
        // getGridParam = function (param) {
        //     return this.jqgridObject.jqGrid("getGridParam", param);
        // }
        //获取单个选中的行的主列值，如果选中多个这返回最后选中的值
        this.getSingleSelectedRowId = () => {
            return this.getSingleSelectedData()[this.euGridOptions.primaryKey];
        };
        //获取所有选中的行的主列值，返回数组
        this.getSelectedRowIds = () => {
            let /** @type {?} */ ids = [];
            let /** @type {?} */ datas = this.aggridOptions.api.getSelectedRows();
            datas.forEach(v => {
                ids.push(v[this.euGridOptions.primaryKey]);
            });
            return ids;
        };
        //返回单个选中的行数据
        this.getSingleSelectedData = () => {
            let /** @type {?} */ datas = this.aggridOptions.api.getSelectedRows();
            return datas[0];
        };
        //返回所有选中行数据的数组
        this.getSelectedDatas = () => {
            return this.aggridOptions.api.getSelectedRows();
        };
        this.convertMap = {
            headerName: "headerName",
            field: "field",
        };
        let /** @type {?} */ cacheBlockSize = this.cacheBlockSize;
        //infinite 模式使用
        this.myDataSource = {
            /**
             * @param {?} params
             * @return {?}
             */
            getRows(params) {
                console.log('asking for ' + params.startRow + ' to ' + params.endRow);
                // At this point in your code, you would call the server, using $http if in AngularJS 1.x.
                // To make the demo look real, wait for 500ms before returning
                // pageService.getPageObol("/ls/list/form/webdiscategorymanage", params.startRow, cacheBlockSize).toPromise().then(data => {
                this.getPageService().getPageObByOffsetLimit("list/e/webdisplaycategory", params.startRow, cacheBlockSize).toPromise().then(data => {
                    var /** @type {?} */ lastRow = -1;
                    if (data.total <= params.endRow) {
                        lastRow = data.total;
                    }
                    params.successCallback(data.contents, lastRow);
                });
            }
        };
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.queryfields = this.euGridOptions.queryfields;
        this.aggridOptions = /** @type {?} */ ({
            columnDefs: this.createColumnDefs(),
            rowModelType: this.rowModelType,
            datasource: this.myDataSource,
            rowData: this.rowData,
            domLayout: 'autoHeight',
            //不出现上下滚动条
            cacheBlockSize: this.cacheBlockSize,
            enableServerSideFilter: true,
            enableColResize: true,
            // pagination: true,
            localeText: localeText,
            enableSorting: this.euGridOptions.suppressRowDrag,
            suppressRowDrag: true,
            enableFilter: false,
            suppressRowClickSelection: false,
            suppressCellSelection: true,
            groupSelectsChildren: true,
            // debug: true,
            rowSelection: 'multiple',
            rowDragManaged: this.euGridOptions.rowDragManaged,
            getRowNodeId: (data) => {
                return data[this.euGridOptions.primaryKey];
            },
            onRowDragEnter: (event) => {
                this.dragEvent.emit(event);
                this.rowDragEnter.emit(event);
            },
            onRowDragEnd: (event) => {
                this.dragEvent.emit(event);
                this.rowDragEnd.emit(event);
            },
            onRowDragMove: (event) => {
                this.dragEvent.emit(event);
                this.rowDragMove.emit(event);
            },
            onRowDragLeave: (event) => {
                this.dragEvent.emit(event);
                this.rowDragLeave.emit(event);
            },
        });
        this.url = this.euGridOptions.url;
        if (this.euGridOptions.width) {
            this.tableWidth = this.euGridOptions.width + 'px';
        }
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.paginator.page.subscribe(data => {
            this.pageSize = this.paginator.pageSize;
            this.pageIndex = this.paginator.pageIndex + 1;
            this.refreshData(this.url, this.pageSize, this.pageIndex, this.cond, this.sidx, this.sord);
        });
        // this.queryForm.form.valueChanges.debounce(() => Observable.interval(400)).subscribe(value => {
        //     this.query()
        // })
        this.queryForm.form.valueChanges.pipe(debounce(() => Observable.interval(400))).subscribe(value => {
            this.query();
        });
        //初始化的查询参数
        this.queryForm.form.patchValue(this.originQueryParams);
    }
    /**
     * @return {?}
     */
    get cond() {
        return Object.assign({}, this.originParams, this.originQueryParams, this._queryParams);
    }
    /**
     * @param {?=} $event
     * @return {?}
     */
    query($event) {
        // debugger
        this._queryParams = this.queryForm.form.value;
        for (let /** @type {?} */ key in this._queryParams) {
            if (this._queryParams[key] == undefined || this._queryParams[key] == "") {
                delete this._queryParams[key];
            }
        }
        let /** @type {?} */ queryParams = {};
        Object.assign(queryParams, this.originParams, this._queryParams, this.originQueryParams);
        this.doQueryParams(queryParams, this.queryfields);
        this.refresh(queryParams);
    }
    /**
     * @param {?=} $event
     * @return {?}
     */
    reset($event) {
        this.queryForm.form.reset();
        this.queryForm.form.patchValue(this.originQueryParams);
        this._queryParams = this.queryForm.form.value;
        this.refresh(this.cond);
    }
    /**
     * @param {?} queryParams
     * @param {?} fields
     * @return {?}
     */
    doQueryParams(queryParams, fields) {
        let /** @type {?} */ rules = [];
        for (let /** @type {?} */ p in queryParams) {
            fields.forEach((v) => {
                if (v.key == p && queryParams[p] && v.op) {
                    if (v.op.advanced) {
                        let /** @type {?} */ filtersbefore = queryParams.filters;
                        let /** @type {?} */ rule = new Rule(v.key, v.op.name, queryParams[p]);
                        rules.push(rule);
                        delete queryParams[p];
                    }
                    // queryParams.
                }
            });
        }
        if (rules.length > 0) {
            let /** @type {?} */ con = new Conditions("AND", rules, []);
            queryParams.filters = con;
        }
    }
    /**
     * @param {?} url
     * @param {?} pageSize
     * @param {?} pageIndex
     * @param {?} cond
     * @param {?} sidx
     * @param {?} sord
     * @return {?}
     */
    refreshData(url, pageSize, pageIndex, cond, sidx, sord) {
        return this.getPageService().getPage(url, pageSize, pageIndex, cond, sidx, sord).then(data => {
            this.length = data.total;
            this.rowData = data.contents;
            this.aggridOptions.api.setRowData(this.rowData);
            // this.rowData = data
        });
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    gridReady($event) {
        this.reComputeSize();
        if (this.rowModelType == 'inMemory') {
            this.getPageService().getPage(this.url, this.pageSize, this.pageIndex, this.cond).then(data => {
                this.length = data.total;
                this.rowData = data.contents;
                this.aggridOptions.api.setRowData(this.rowData);
                // this.rowData = data
            });
        }
    }
    /**
     * @return {?}
     */
    reComputeSize() {
        this.aggridOptions.api.sizeColumnsToFit();
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onSortChanged($event) {
        let /** @type {?} */ sortModel = this.aggridOptions.api.getSortModel();
        let /** @type {?} */ sortCol = sortModel[0];
        if (sortCol) {
            this.sidx = sortCol.colId;
            this.sord = sortCol.sort;
            setTimeout(() => {
                this.refresh();
            });
        }
    }
    /**
     * @return {?}
     */
    createColumnDefs() {
        if (this.euColModels) {
            let /** @type {?} */ colDefs;
            this.euColModels.forEach(value => {
                // colDefs
            });
            return colDefs;
        }
        else {
            this.attachComparatorToColDefs(this.agGridColDefs);
            return this.agGridColDefs;
        }
    }
    /**
     * @param {?} defs
     * @return {?}
     */
    attachComparatorToColDefs(defs) {
        defs.forEach((v) => {
            if (v.children) {
                this.attachComparatorToColDefs(v.children);
            }
            else {
                v.comparator = function (valueA, valueB, nodeA, nodeB, isInverted) {
                    return 0;
                };
            }
        });
    }
    /**
     * @param {?} modalConfig
     * @param {?} data
     * @return {?}
     */
    openDialog(modalConfig, data) {
        if (!modalConfig.data) {
            modalConfig.data = {};
        }
        Object.assign(modalConfig.data, data);
        this.euModalService.open(modalConfig, (result) => {
            this.refresh();
        }, (result) => {
            this.refresh();
        });
    }
    /**
     * @param {?} action
     * @return {?}
     */
    onAction(action) {
        let /** @type {?} */ ids = this.getSelectedRowIds();
        let /** @type {?} */ datas = this.getSelectedDatas();
        let /** @type {?} */ ege = new EuGridEvent(this.euGridOptions.gridId, action, ids.length > 0 ? ids[0] : undefined, ids, datas.length > 0 ? datas[0] : undefined, datas, this.getActionParams(action.key));
        if (action instanceof CURDAction) {
            switch (action.curdType) {
                case CURDAction.TYPE_CREATE:
                    let /** @type {?} */ modalConfig = action.modalConfig || this.euGridOptions.defaultActionModalConfig;
                    this.openDialog(modalConfig, {
                        euGridEvent: ege
                    });
                    break;
                case CURDAction.TYPE_UPDATE:
                    if (ids.length == 1) {
                        let /** @type {?} */ modalConfig1 = action.modalConfig || this.euGridOptions.defaultActionModalConfig;
                        this.openDialog(modalConfig1, { euGridEvent: ege });
                    }
                    else {
                        this.snackBar.open('请选择一条记录！', '关闭', {
                            duration: 800
                        });
                    }
                    break;
                case CURDAction.TYPE_QUERY:
                    this.queryExpanded = !this.queryExpanded;
                    break;
                case CURDAction.TYPE_READ:
                    this.refresh();
                    break;
                case CURDAction.TYPE_DELETE:
                    break;
                default:
            }
        }
        else {
            //有modal配置就是要打开modal咯
            if (action && action.modalConfig) {
                this.openDialog(action.modalConfig, { euGridEvent: ege });
            }
        }
        this.euGridEvent.emit(ege);
    }
    /**
     * @param {?=} params
     * @return {?}
     */
    refresh(params) {
        this.refreshData(this.url, this.pageSize, this.pageIndex, params || this.cond, this.sidx, this.sord);
    }
    /**
     * @param {?=} suppress
     * @return {?}
     */
    toggleSuppressRowDrag(suppress) {
        if (suppress == undefined) {
            this.aggridOptions.api.setSuppressRowDrag(!this.aggridOptions.suppressRowDrag);
        }
        else {
            this.aggridOptions.api.setSuppressRowDrag(suppress);
        }
    }
    /**
     * @param {?} params
     * @param {?=} fresh
     * @return {?}
     */
    setParams(params, fresh) {
        this.originParams = params;
        if (fresh) {
            this.refresh();
        }
    }
    /**
     * 设置action的外部参数（非rowId这些）
     * @param {?} actionKey
     * @param {?} param
     * @param {?=} all 是否所有action生效
     * @return {?}
     */
    setActionParams(actionKey, param, all) {
        if (all) {
            this.actionParams.all = param;
        }
        else {
            this.actionParams[actionKey] = param;
        }
    }
    /**
     * @param {?} key
     * @return {?}
     */
    getActionParams(key) {
        return Object.assign({}, this.actionParams[key], this.actionParams.all);
    }
    /**
     * @param {?} col
     * @return {?}
     */
    enColModelToAgColDef(col) {
        let /** @type {?} */ colDef = {
            headerName: "编号",
            field: "categoryNo",
            checkboxSelection: function (params) {
                // we put checkbox on the name if we are not doing grouping
                return params.columnApi.getRowGroupColumns().length === 0;
            },
            headerCheckboxSelection: function (params) {
                // we put checkbox on the name if we are not doing grouping
                return params.columnApi.getRowGroupColumns().length === 0;
            },
        };
        return colDef;
    }
    /**
     * @return {?}
     */
    getPageService() {
        return this.inputPageService || this.pageService;
    }
}
AggridComponent.decorators = [
    { type: Component, args: [{
                selector: 'eu-aggrid',
                template: "<div [style.width]=\"tableWidth\"> <h1>{{euGridOptions.title}}</h1> <div style=\"display: flex;\"> <span style=\"flex: 1 1 auto;\"></span> <button mat-icon-button [color]=\"action.style\" (click)=\"onAction(action)\" *ngFor=\"let action of euGridOptions.actions\"> <mat-icon class=\"mat-24\"  [matTooltip]=\"action.name\"  matTooltipPosition=\"above\" [attr.aria-label]=\"action.name\" [attr.title]=\"action.name\"> {{action.icon}} </mat-icon> </button> </div> <mat-expansion-panel [expanded]=\"queryExpanded\"> <ef-md-form [fields]=\"queryfields\"></ef-md-form> <mat-action-row> <button mat-button (click)=\"query($event)\">查询</button> <button mat-button (click)=\"reset($event)\">重置</button> </mat-action-row> </mat-expansion-panel> <!-- class=\"ag-blue\"  --> <div class=\"eu-md-table-container\"> <ag-grid-angular style=\"width: 100%;\" class=\"ag-theme-material\" [gridOptions]=\"aggridOptions\" (gridReady)=\"gridReady($event)\" (sortChanged)=\"onSortChanged($event)\"> </ag-grid-angular> </div> <mat-paginator #paginator [length]=\"length\" [pageSize]=\"pageSize\" [pageSizeOptions]=\"pageSizeOptions\" (page)=\"pageEvent = $event\"> </mat-paginator> </div>",
                //     styles: [
                //         `
                // .eu-md-table-container {
                //     transition: box-shadow 280ms cubic-bezier(.4,0,.2,1);
                //     display: block;
                //     position: relative;
                //     /* padding: 24px; */
                //     border-radius: 2px;
                //     background: #fff;
                //     color: rgba(0,0,0,.87);
                //     box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);
                // }
                // `,
                //     ],
                styles: ["/* @import \"~ag-grid/dist/styles/ag-grid.css\"; */ /* @import \"../node_modules/ag-grid/dist/styles/theme-blue.css\"; */ /* @import \"~ag-grid/dist/styles/ag-theme-material.css\"; */ .eu-md-table-container { transition: box-shadow 280ms cubic-bezier(.4,0,.2,1); display: block; position: relative; /* padding: 24px; */ border-radius: 2px; background: #fff; color: rgba(0,0,0,.87); box-shadow: 0 5px 5px -3px rgba(0,0,0,.2), 0 8px 10px 1px rgba(0,0,0,.14), 0 3px 14px 2px rgba(0,0,0,.12);     }"],
                encapsulation: ViewEncapsulation.None
            },] },
];
/** @nocollapse */
AggridComponent.ctorParameters = () => [
    { type: EuModalService, },
    { type: EuPageService, decorators: [{ type: Optional },] },
    { type: MatDialog, },
    { type: MatSnackBar, },
];
AggridComponent.propDecorators = {
    "euColModels": [{ type: Input },],
    "euGridOptions": [{ type: Input },],
    "agGridColDefs": [{ type: Input },],
    "rowModelType": [{ type: Input },],
    "inputPageService": [{ type: Input },],
    "url": [{ type: Input },],
    "tableWidth": [{ type: Input },],
    "originParams": [{ type: Input },],
    "originQueryParams": [{ type: Input },],
    "paginator": [{ type: ViewChild, args: [MatPaginator,] },],
    "queryForm": [{ type: ViewChild, args: [MdFormComponent,] },],
    "euGridEvent": [{ type: Output },],
    "dragEvent": [{ type: Output },],
    "rowDragEnter": [{ type: Output },],
    "rowDragEnd": [{ type: Output },],
    "rowDragMove": [{ type: Output },],
    "rowDragLeave": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class EasyUIagGridModule {
}
EasyUIagGridModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    MatButtonModule,
                    MatIconModule,
                    MatPaginatorModule,
                    MatTooltipModule,
                    MatSnackBarModule,
                    MatInputModule,
                    MatExpansionModule,
                    EasyFormMdModule,
                    AgGridModule.withComponents([]),
                ],
                exports: [
                    AggridComponent,
                ],
                declarations: [
                    AggridComponent
                ],
                providers: [],
                entryComponents: []
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { EasyUIagGridModule, AggridComponent };
//# sourceMappingURL=eu-ag-grid.js.map
