import { OnInit, EventEmitter } from '@angular/core';
import { HttpClient } from "@angular/common/http";
import { MatSnackBar } from "@angular/material";
import { OnAction, TreeAction, TreeEvent, EuTreeNode, EuTreeOptions, ModalConfig, EuModalService, EuTreeService, EuTree } from "ng2-easyui.core";
import { NzTreeComponent } from "ng-tree-antd";
import { TreeNode } from "angular-tree-component";
export declare class AntdTreeComponent implements OnInit, OnAction, EuTree {
    private httpClient;
    private treeService;
    private euModalService;
    snackBar: MatSnackBar;
    euTreeNodes: EuTreeNode[];
    euTreeOptions: EuTreeOptions;
    nzShiftSelectedMulti: boolean;
    treeEvent: EventEmitter<TreeEvent>;
    euTreeCheck: EventEmitter<{
        checked: boolean;
        eventName: string;
        euTreeNode: EuTreeNode;
        node: any;
    }>;
    select: EventEmitter<any>;
    deselect: EventEmitter<any>;
    check: EventEmitter<any>;
    decheck: EventEmitter<any>;
    initialized: EventEmitter<any>;
    nzTree: NzTreeComponent;
    inputTreeService: EuTreeService;
    params: any;
    autoParams: string[];
    nzCheckable: boolean;
    nzShowLine: boolean;
    _dataUrl: string;
    _nzOptions: any;
    _nzNodes: any[];
    constructor(httpClient: HttpClient, treeService: EuTreeService, euModalService: EuModalService, snackBar: MatSnackBar);
    ngOnInit(): void;
    onEvent(event: any): void;
    onCheck(e: any): void;
    onDeCheck(e: any): void;
    onActivate(e: any): void;
    onDeActivate(e: any): void;
    onNzLoadNodeChildren($event: any): void;
    /**
     *
     * @param modalConfig
     * @param data
     * @param node node to refresh
     */
    openDialog(modalConfig: ModalConfig, data: any, node: TreeNode): void;
    euOnAction(baseAction: TreeAction): void;
    refresh(params: any, node?: EuTreeNode, openState?: any, checkState?: any, selectedState?: any): void;
    getNodeById(id: string): EuTreeNode;
    setSelectedNode(idOrNode: string | EuTreeNode, selected: boolean): void;
    setActiveNode(idOrNode: string | EuTreeNode, selected: boolean): any;
    private getNodes(params, node?);
    private treeAsyncSuccess(ztree, openState, checkState, selectedState, openNodes, checkedNodes, selectedNodes);
    refreshSelectedNode(): void;
    refreshActiveNode(): void;
    refreshSelectedNodeParent(): void;
    refreshActiveNodeParent(): void;
    private refreshNode(node, id?, pid?);
    getSelectedNode(): EuTreeNode;
    /**
     * 获取一个选择的node
     */
    getActiveDefNode(): EuTreeNode;
    getSelectedNodes(): Array<EuTreeNode>;
    getActiveDefNodes(): Array<EuTreeNode>;
    private getActiveNodes();
    private checkedLeafNodes;
    private checkedParentNodes;
    private checkedNodes;
    getCheckedNodes(checked?: boolean): Array<EuTreeNode>;
    refreshTree(): void;
    private getTreeService();
    private treeNodeToEuTreeNode(node);
}
