import { OnInit, EventEmitter, AfterViewInit } from '@angular/core';
import { AbstractControl, FormControl, FormGroup } from "@angular/forms";
import { FormGroupDirective, NgForm } from "@angular/forms";
import { ErrorStateMatcher } from "@angular/material";
import { EuTreeNode, EuTreeOptions, TreeEvent, EuTreeService } from "ng2-easyui.core";
import { TreeWrapComponent } from "./tree-wrapper";
import { FieldBase } from "ng2-easyform";
import { SelectTreeField } from "./select-tree.field";
import { TreeSelectChange } from "./select-tree.input";
/** Error when invalid control is dirty, touched, or submitted. */
export declare class DefaultErrorStateMatcher implements ErrorStateMatcher {
    isErrorState(control: FormControl | null, form: FormGroupDirective | NgForm | null): boolean;
}
export declare class SelectTreeComponent implements OnInit, AfterViewInit {
    fieldControl: AbstractControl;
    field: SelectTreeField;
    form: FormGroup;
    label: string;
    span: number;
    euTreeNodes: EuTreeNode[];
    euTreeOptions: EuTreeOptions;
    nzShiftSelectedMulti: boolean;
    /** An object used to control when error messages are shown. */
    errorStateMatcher: ErrorStateMatcher;
    treeEvent: EventEmitter<TreeEvent>;
    inputTreeService: EuTreeService;
    tree: TreeWrapComponent;
    constructor();
    ngOnInit(): void;
    ngDoCheck(): void;
    ngAfterViewInit(): void;
    onTreeSelectChange($event: TreeSelectChange): void;
    close(): void;
    onTreeEvent($event: any): void;
    _clear(e: any): void;
    _getFormControl(field: FieldBase<any>): FormControl;
}
